package basics.datagraph;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javatools.database.WordNet;

/**
 * Class WordNetClass
 *
 * @author Fabian M. Suchanek
 */
public class WordNetClass extends YagoClass {

  /** Holds the wordnet id*/
  protected int wordNetId = -1;

  /** Holds the main concept */
  protected String mainConcept=null;
  
  public WordNetClass(String mainConcept, int wordNetId){
    this(mainConcept,wordNetId,new ArrayList<YagoClass>(0));
  }
  public WordNetClass(String mainConcept, int wordNetId, YagoClass superclass){
    this(mainConcept,wordNetId,Arrays.asList(superclass));
  }
  public WordNetClass(String mainConcept, int wordNetId, List<YagoClass> superclasses){
    super("wordnet_"+(mainConcept.replace(' ','_'))+"_"+wordNetId, superclasses);
    this.wordNetId = wordNetId;
    this.mainConcept=mainConcept;
  }
  
  /** Returns a wordnet synset (null)*/
  public WordNet.Synset synset(WordNet w) {
    if (wordNetId== -1) return (null);
    return (w.getSynset(wordNetId));
  }

  /** Returns the wordnet id*/
  public int wordNetId() {
    return wordNetId;
  }
  
  /** Returns the main concept*/
  public String mainConcept(){
    return mainConcept;
  }
  
}
