package basics.datagraph.virtualRelations;

import java.util.Collection;

import javatools.parsers.DateParser;
import javatools.parsers.Name;
import javatools.parsers.NumberParser;
import basics.datagraph.Relation;
import basics.datagraph.VirtualRelation;
import basics.datagraph.YagoClass;

public class DisjointRelation extends VirtualRelation {

  public DisjointRelation(String name, YagoClass domain, YagoClass range, Relation superRelation, Collection<YagoClass> types) {
    super(name, domain, range, superRelation, types);
  }


  public boolean holds(String x, String y) {
    if(DateParser.isDate(x) && DateParser.isDate(y)) {
      return (DateParser.disjoint(x, y));
    }
    if(NumberParser.isFloat(x) && NumberParser.isFloat(y)) {
      return (NumberParser.different(x, y));
    }
    if (x.contains(",") && Name.isUSState(y)) {
      return (!x.replace('_', ' ').split(",[ _]++")[1].trim().equalsIgnoreCase(y.replace('_', ' ')));
    }
    if (y.contains(",") && Name.isUSState(x)) {
      return (!y.replace('_', ' ').split(",[ _]++")[1].trim().equalsIgnoreCase(x.replace('_', ' ')));
    }
    return (!x.equals(y));
  }
}
