package basics.datagraph.virtualRelations;

import java.util.Collection;

import javatools.parsers.DateParser;
import basics.datagraph.Relation;
import basics.datagraph.VirtualRelation;
import basics.datagraph.YagoClass;

public class LifeTimeRelation extends VirtualRelation {

  public LifeTimeRelation(String name, YagoClass domain, YagoClass range, Relation superRelation, Collection<YagoClass> types) {
    super(name, domain, range, superRelation, types);
  }


  public boolean holds(String born, String died) {
    try {
      int yearborn = Integer.parseInt(DateParser.getDate(born)[0].replace('#', '9'));
      int yeardied = Integer.parseInt(DateParser.getDate(died)[0].replace('#', '0'));
      return (yeardied > yearborn && yeardied - yearborn < 100);
    } catch (Exception e) {
    }
    return (false);
  }

}
